LeetCode438.找到字符串中所有字母异位词

因为之前写过一道找字母异位词分组的题,所以这道题做起来还是比较得心应手。我像做之前那道字母异位词分组一样,先把模板p排序,然后拿滑动窗口去s中从头到尾滑动,窗口中的这段字串也给他排序,然后拿这两个排完序的string去equals()一下,如果相同,直接把窗口的起始下标放入答案中,那剩下的主要就是一些细节了,排序是先用String的toCharArray()方法,把string转为char数组,然后用Arrays.sort()方法把字符数组排序,最后用String.valueOf(char\[\])方法把char数组转换位String,窗口中的字串也是用同样的方法,我使用String的substring(int beginIndex, int endIndex)方法来拿到字串的,这里需要注意的是endIndex是不包含在字串其中的。最后两个string比较equals一下就可以,以下是我的代码:

java 复制代码
class Solution {
    public List<Integer> findAnagrams(String s, String p) {
      List<Integer> ans = new ArrayList<Integer>();
      char[] c = p.toCharArray();
      Arrays.sort(c);
      String ss = String.valueOf(c);
      int l = c.length;
      int n = s.length();
      for(int i = 0;i<=n-l;i++){
         int j = i+l;
         if(j<=n){
            String sub = s.substring(i,j);
             char[] subc =sub.toCharArray();
            Arrays.sort(subc);
            String sub2 = String.valueOf(subc);
            if(sub2.equals(ss)){
                ans.add(i);
            }
         }else{
             break;
         }
      }
      return ans;
    }
}

看了一下题解,题解为了更高的算法执行效率并没有用排序,而是统计窗口中所有字母出现的次数与模板中所有字母出现的次数进行比较,如果出现的次数相同,那字串和模板就是异位词。

java 复制代码
class Solution {
    public List<Integer> findAnagrams(String s, String p) {
        int sLen = s.length(), pLen = p.length();

        if (sLen < pLen) {
            return new ArrayList<Integer>();
        }

        List<Integer> ans = new ArrayList<Integer>();
        int[] sCount = new int[26];
        int[] pCount = new int[26];
        for (int i = 0; i < pLen; ++i) {
            ++sCount[s.charAt(i) - 'a'];
            ++pCount[p.charAt(i) - 'a'];
        }

        if (Arrays.equals(sCount, pCount)) {
            ans.add(0);
        }

        for (int i = 0; i < sLen - pLen; ++i) {
            --sCount[s.charAt(i) - 'a'];
            ++sCount[s.charAt(i + pLen) - 'a'];

            if (Arrays.equals(sCount, pCount)) {
                ans.add(i + 1);
            }
        }

        return ans;
    }
}

他是创建两个大小位26的int数组scount和pcount,然后通过++sCounts.charAt(i) - 'a';统计字母出现的次数,然后也是通过窗口的特点,就是进来一个加上一个,出去一个减掉一个,所以可以发现,在第一次初始化完count数组后窗口不断右移,左边在把scount--,右边在把scount++。

相关推荐
碧海银沙音频科技研究院8 分钟前
基于炬芯平台ATS308X多模型兼容语音识别算法
人工智能·算法·语音识别
爱读书的小胖26 分钟前
LeetCode 274 H 指数 C 语言解题分析
c语言·算法·leetcode·1024程序员节
IT_Octopus36 分钟前
Apollo 配置中心入门:一所“小学校“读懂 Portal、Meta Server、Config Service
java·后端·spring
cfm_291437 分钟前
偏向锁的Epoch优化机制
java
basketball6161 小时前
动态规划第一章:引论
算法·动态规划·1024程序员节
CRMEB系统商城1 小时前
家电零售的供应商协同与物流提效
java·开发语言·人工智能·小程序·1024程序员节
jason.zeng@15022071 小时前
Nginx 配置详解(静态 HTML、下载目录、API 反向代理三套场景)
java·vue.js·1024程序员节
星夜离尘561 小时前
MATLAB 因果采样保持:用历史匹配和数据年龄防止未来信息泄漏
数据结构·算法·matlab
鬼手点金1 小时前
从 API 消息到模型 Token:Chat Template
java·前端·javascript·数据库·人工智能·深度学习·1024程序员节
Shadow(⊙o⊙)1 小时前
LangChain 自定义工具全解析:从 @tool 到 bind_tools 的完整调用链路
java·服务器·前端·1024程序员节